///////////////////////////////////////////////////////////////////////////////
//
//    (C) Copyright 1995 - 2000 OSR Open Systems Resources, Inc.
//    All Rights Reserved
//
//    This sofware is supplied for instructional purposes only.
//
//    OSR Open Systems Resources, Inc. (OSR) expressly disclaims any warranty
//    for this software.  THIS SOFTWARE IS PROVIDED  "AS IS" WITHOUT WARRANTY
//    OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING, WITHOUT LIMITATION,
//    THE IMPLIED WARRANTIES OF MECHANTABILITY OR FITNESS FOR A PARTICULAR
//    PURPOSE.  THE ENTIRE RISK ARISING FROM THE USE OF THIS SOFTWARE REMAINS
//    WITH YOU.  OSR's entire liability and your exclusive remedy shall not
//    exceed the price paid for this material.  In no event shall OSR or its
//    suppliers be liable for any damages whatsoever (including, without
//    limitation, damages for loss of business profit, business interruption,
//    loss of business information, or any other pecuniary loss) arising out
//    of the use or inability to use this software, even if OSR has been
//    advised of the possibility of such damages.  Because some states/
//    jurisdictions do not allow the exclusion or limitation of liability for
//    consequential or incidental damages, the above limitation may not apply
//    to you.
//
//    OSR Open Systems Resources, Inc.
//    105 Route 101A Suite 19
//    Amherst, NH 03031  (603) 595-6500 FAX: (603) 595-6503
//    email bugs to: bugs@osr.com
//
//
//    MODULE:
//
//        OSRNTAPI_IOCTL.H
//
//    ABSTRACT:
//
//      This file contains IOCTL definitions for the OSR NTAPI driver.
//		User applications need to ensure that winioctl.h is #included.
//
//    AUTHOR(S):
//
//        OSR Open Systems Resources, Inc.
// 
//    REVISION:   
//
//
///////////////////////////////////////////////////////////////////////////////

//
// This header file contains all declarations shared between driver and user
// applications.
//

#ifndef __OSRNTAPI_IOCTL_H__
#define __OSRNTAPI_IOCTL_H__ (1)

//
// The following value is arbitrarily chosen from the space defined by Microsoft
// as being "for non-Microsoft use"
//
#define FILE_DEVICE_OSR 0x0F53

//
// Device control codes - values between 2048 and 4095 arbitrarily chosen
//
#define IOCTL_OSR_ENABLE_LOGGING    CTL_CODE(FILE_DEVICE_OSR, 2050, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_OSR_DISABLE_LOGGING   CTL_CODE(FILE_DEVICE_OSR, 2051, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_OSR_EXECUTE_WORK_ITEM CTL_CODE(FILE_DEVICE_OSR, 2052, METHOD_BUFFERED, FILE_ANY_ACCESS)


#endif /* __OSRNTAPI_IOCTL_H__ */

